/* 
original formula)
THL:=IF(HHV(HIGH,5)-LLV(LOW,5)=0,0.000001,HHV(HIGH,5)-LLV(LOW,5)); 5 period maximum range

STXV:=SUM(V,5);  5 period total volume

BSPV:=SUM(((C-REF(O,-4))/THL)*STXV,20)/SUM(STXV,20);  5 period true range/5 period max range *
5 period total volume i.e. 5 period true volume with direction; higher BSPVabs would indicate
strong price&volume correlation.  

BSPVU:=IF(BSPV>=0,1,null);
{ -This is a binary osc. plotted as histogram, this is the blue plot}
BSPVD:=IF(BSPV<=0,-1,null);
{ -This is a binary osc. plotted as histogram, this is the red plot}
LN:=0;

*/

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 LimeGreen
#property indicator_maximum 1
#property indicator_minimum -1

//---- input parameters
extern int ShortPeriod=5;
extern int LongPeriod=20;

//---- buffers
double THL[];
double STXV[];
double BSPV[];
double BSPVU[],BSPVD[],Temp[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(6);
   SetIndexBuffer(2, THL);
   SetIndexBuffer(3, STXV);
   SetIndexBuffer(4, BSPV);
   SetIndexBuffer(5, Temp);
//---- indicator lines
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(0,BSPVU);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(1,BSPVD);
//---- name for DataWindow and indicator subwindow label
   short_name="BSPVolume";
   IndicatorShortName(short_name);

   SetIndexLabel(2, "THL");
   SetIndexLabel(3, "STXV");
   SetIndexLabel(4, "BSPV");
   SetIndexLabel(5, "Temp");
//---- indicator lines
  
   SetIndexLabel(0,"BSPVU");
   
   SetIndexLabel(1,"BSPVD");   
//----
   SetIndexDrawBegin(0,LongPeriod);
//----

    ObjectCreate("7",OBJ_LABEL,0,10,10);
    ObjectSet("7",OBJPROP_XDISTANCE,2);
    ObjectSet("7",OBJPROP_YDISTANCE,27);
    ObjectSet("7",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("7","More free good indicators to go FX141 download FX141.COM",11,"SimSun",Yellow);


    ObjectCreate("9",OBJ_LABEL,0,10,10);
    ObjectSet("9",OBJPROP_XDISTANCE,2);
    ObjectSet("9",OBJPROP_YDISTANCE,12);
    ObjectSet("9",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("9","Indicator Source FX141 Network Free Download FX141.COM",11,"SimSun",DeepPink);

   return(0);
  }
//+------------------------------------------------------------------+
//| BSPVolume                                       
//+------------------------------------------------------------------+
int start()
 {
   int    i,k,counted_bars=IndicatorCounted();
   
   if(Bars<=LongPeriod) return(0);
//---- initial zero
/* 
  if(counted_bars<1)
     {
      for(i=1;i<=CCIPeriod;i++) CCIBuffer[Bars-i]=0.0;
      for(i=1;i<=CCIPeriod;i++) DevBuffer[Bars-i]=0.0;
      for(i=1;i<=CCIPeriod;i++) MovBuffer[Bars-i]=0.0;
     }
*/
//---- last counted bar will be recounted
   int limit=Bars-counted_bars;
   if (counted_bars>0) limit++; else limit-=LongPeriod;
//---- THL:=IF(HHV(HIGH,5)-LLV(LOW,5)=0,0.000001,HHV(HIGH,5)-LLV(LOW,5));
   
   double t;
   for(i=0; i<limit; i++)
      {t=High[Highest(NULL,0,MODE_HIGH,ShortPeriod,i)]-Low[Lowest(NULL,0,MODE_LOW,ShortPeriod,i)];
       if (t==0) THL[i]=0.000001; else THL[i]=t;}
    
//---- STXV:=SUM(V,5);
   for(i=0; i<limit; i++)
      {t=0;
      for (k=0;k<ShortPeriod;k++)
          t+=Volume[i+k];
          STXV[i]=t;}
   
//---- BSPV:=SUM(((C-REF(O,-4))/THL)*STXV,20)/SUM(STXV,20);
   for(i=0; i<limit; i++)
   Temp[i]=((Close[i]-Open[i+4])/THL[i])*STXV[i];
   
   double sum1,sum2;
   for(i=0; i<limit; i++)
   {sum1=0;sum2=0;
      for (k=0;k<LongPeriod;k++)
          {sum1+=Temp[i+k];
          sum2+=STXV[i+k];}
   BSPV[i]=sum1/sum2;}

/*BSPVU:=IF(BSPV>=0,1,null);
{ -This is a bianary osc. plot as histogram, this is the blue plot}
BSPVD:=IF(BSPV<=0,-1,null);
{ -This is a bianary osc. plotted as histogram, this is the red plot}
LN:=0;*/

   for(i=0; i<limit; i++)
   if (BSPV[i]>0)
      {BSPVU[i]=1;BSPVD[i]=0;}
      
      else if (BSPV[i]<0)
          {BSPVU[i]=0;BSPVD[i]=-1;}
          
            else {BSPVU[i]=1;BSPVD[i]=-1;}
   
}