/* 
original formula)
THL:=IF(HHV(HIGH,5)-LLV(LOW,5)=0,0.000001,HHV(HIGH,5)-LLV(LOW,5));

VM:=SUM(VOLUME,5);

VIX:=SUM(((((2*C)-HHV(HIGH,5))-LLV(LOW,5)))/(THL)*VM,13)/SUM(VM,13);

VIXu:=IF(VIX>0 AND VIX>0.1300,VIX,null);
{- This gives the blue histo bars that are above .1300}
VIXd:=IF(VIX<0 AND VIX<-0.1300,VIX,null);
{- This gives the red histo bars that are below -.1300}
VIXnu:=IF(VIX>0 AND VIX <0.1300,VIX,null);
{- neutral yellow histo bars (up)}
VIXnd:=IF(VIX<0 AND VIX> -0.1300,VIX,null);
{-neutral yellow histo bars (down)}
TRu:=VIXu;
TRd:=VIXd;
LN:=0;

*/

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 White


//---- input parameters
extern int ShortPeriod=5;
extern int LongPeriod=13;

//---- buffers
double THL[];
double VM[];
double VIX[];
double VIXU[],VIXD[],VIXN[],sum1[],sum2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(8);
   SetIndexBuffer(3, THL);
   SetIndexBuffer(4, VM);
   SetIndexBuffer(5, VIX);
   SetIndexBuffer(6,sum1);
   SetIndexBuffer(7,sum2);
   
//---- indicator lines
   SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
   SetIndexBuffer(0,VIXU);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,2);
   SetIndexBuffer(1,VIXD);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,2);
   SetIndexBuffer(2,VIXN);
//---- name for DataWindow and indicator subwindow label
   short_name="VRatio";
   IndicatorShortName(short_name);
   
//----
   SetIndexDrawBegin(0,LongPeriod);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| BSPVolume                                       
//+------------------------------------------------------------------+
int start()
 {
   int    i,k,counted_bars=IndicatorCounted();
   
   if(Bars<=LongPeriod) return(0);
//---- initial zero
/* 
  if(counted_bars<1)
     {
      for(i=1;i<=CCIPeriod;i++) CCIBuffer[Bars-i]=0.0;
      for(i=1;i<=CCIPeriod;i++) DevBuffer[Bars-i]=0.0;
      for(i=1;i<=CCIPeriod;i++) MovBuffer[Bars-i]=0.0;
     }
*/
//---- last counted bar will be recounted
   int limit=Bars-counted_bars;
   if (counted_bars>0) limit++; else limit-=LongPeriod;
//---- THL:=IF(HHV(HIGH,5)-LLV(LOW,5)=0,0.000001,HHV(HIGH,5)-LLV(LOW,5));
   
   double t;
   for(i=0; i<limit; i++)
      {t=High[Highest(NULL,0,MODE_HIGH,ShortPeriod,i)]-Low[Lowest(NULL,0,MODE_LOW,ShortPeriod,i)];
       if (t==0) THL[i]=0.000001; else THL[i]=t;}
    
//---- VM:=SUM(VOLUME,5);
t=0;
      for (k=0;k<ShortPeriod;k++)
          t+=Volume[k];VM[0]=t;
      for(i=1; i<limit; i++)
      {t-=Volume[i-1];t+=Volume[i-1+ShortPeriod];VM[i]=t;}
   
//---- VIX:=SUM(((((2*C)-HHV(HIGH,5))-LLV(LOW,5)))/(THL)*VM,13)/SUM(VM,13);
      
   double s1=0,s2=0;
   for(i=0; i<limit; i++)
   {s1=Close[i]*2-High[Highest(NULL,0,MODE_HIGH,ShortPeriod,i)]-Low[Lowest(NULL,0,MODE_LOW,ShortPeriod,i)];
    s1=s1/THL[i];
    sum1[i]=s1*VM[i];}
    
   for(i=0; i<limit; i++)
      {for (k=0;k<LongPeriod;k++)
          {s1+=sum1[i+k];
          s2+=VM[i+k];}
   VIX[i]=s1/s2;s1=0;s2=0;}

/*VIXu:=IF(VIX>0 AND VIX>0.1300,VIX,null);
{- This gives the blue histo bars that are above .1300}
VIXd:=IF(VIX<0 AND VIX<-0.1300,VIX,null);
{- This gives the red histo bars that are below -.1300}
VIXnu:=IF(VIX>0 AND VIX <0.1300,VIX,null);
{- neutral yellow histo bars (up)}
VIXnd:=IF(VIX<0 AND VIX> -0.1300,VIX,null);
{-neutral yellow histo bars (down)}*/
   double l;
   l=LongPeriod; l=l/100;
   for(i=0; i<limit; i++)
   if (VIX[i]>l)
      {VIXU[i]=VIX[i];VIXD[i]=0;VIXN[i]=0;}
      
      else if (VIX[i]<(-l))
          {VIXU[i]=0;VIXD[i]=VIX[i];VIXN[i]=0;}
          
            else {VIXU[i]=0;VIXD[i]=0;VIXN[i]=VIX[i];}
   
}