
//+------------------------------------------------------------------+
//|                                                 Volumomentum.mq4 |
//|                      Copyright ?2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

/* 
original formula)
L1:=(SUM(TP()*VOLUME,12)/SUM(VOLUME,12))-(SUM(TP()*VOLUME,26))/SUM(VOLUME,26);

WBP:=(HHV(HIGH,5)+LLV(LOW,5)+CLOSE)/3;
WV:=SUM(VOLUME,5);

L2:=(SUM(WBP*WV,12)/SUM(WV,12))-(SUM(WBP*WV,26))/SUM(WV,26);

NBP:=(HHV(HIGH,20)+LLV(LOW,20)+CLOSE)/3;
MV:=SUM(VOLUME,20);

L3:=(SUM(NBP*MV,12)/SUM(MV,12))-(SUM(NBP*MV,26))/SUM(MV,26);

VM:=(L1+(L2*2)+(L3*3))/6;

VMU:=IF(VM>0,VM,null);
{ - this will be the blue histo bars}
VMD:=IF(VM<0,VM,null);
{ - this will be the red histo bars}
CC:=MOV(VM,19,E);
CCS:=REF(CC,-2);
{ -Plots the white moving ave, shifted forward 2 periods as a histogram}
LN:=0;

*/

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 White


//---- input parameters


//---- buffers
double L1[],L2[],L3[];

double VM[];
double VMU[],VMD[],CC[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 3 additional buffers are used for counting.
   IndicatorBuffers(7);
   SetIndexBuffer(3,L1);
   SetIndexBuffer(4,L2);
   SetIndexBuffer(5,L3);

   SetIndexBuffer(6,VM);
   
//---- indicator lines
   SetIndexStyle(0,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(0,VMU);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(1,VMD);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,2);
   SetIndexBuffer(2,CC);
   SetIndexShift(2,2);
//---- name for DataWindow and indicator subwindow label
   short_name="Volumomentum";
   IndicatorShortName(short_name);
   
//----
   SetIndexDrawBegin(0,100);

    ObjectCreate("7",OBJ_LABEL,0,10,10);
    ObjectSet("7",OBJPROP_XDISTANCE,2);
    ObjectSet("7",OBJPROP_YDISTANCE,27);
    ObjectSet("7",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("7","More free good indicators to go FX141 download FX141.COM",11,"SimSun",Yellow);


    ObjectCreate("9",OBJ_LABEL,0,10,10);
    ObjectSet("9",OBJPROP_XDISTANCE,2);
    ObjectSet("9",OBJPROP_YDISTANCE,12);
    ObjectSet("9",OBJPROP_CORNER,CORNER_LEFT_LOWER);
    ObjectSetText("9","Indicator Source FX141 Network Free Download FX141.COM",11,"SimSun",DeepPink);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//|   Volumomentum                                                   |
//+------------------------------------------------------------------+
int start()
 {
   int    i,k,counted_bars=IndicatorCounted();
   double t1,t2,t3,t4;int t0;
   if(Bars<=100) return(0);

   int limit=Bars-counted_bars;
   if (counted_bars>0) limit++; else if (limit>300) limit=300;

//---- L1:=(SUM(TP()*VOLUME,12)/SUM(VOLUME,12))-(SUM(TP()*VOLUME,26))/SUM(VOLUME,26);
   
   
   for(i=0;i<limit;i++)
      {t1=0;t2=0;t3=0;t4=0;
       for(k=0;k<12;k++)
          {t0=i+k;
          t1=t1+Volume[t0]*(High[t0]+Low[t0]+Close[t0])/3;
          t2=t2+Volume[t0];}
       t3=t1;
       t4=t2;
       for(k=12;k<26;k++)
          {t0=i+k;
          t3=t3+Volume[t0]*(High[t0]+Low[t0]+Close[t0])/3;
          t4=t4+Volume[t0];}
       L1[i]=t1/t2-t3/t4;}
       
   
//----WBP:=(HHV(HIGH,5)+LLV(LOW,5)+CLOSE)/3;
//----WV:=SUM(VOLUME,5);   
   
      
    
//---- L2:=(SUM(WBP*WV,12)/SUM(WV,12))-(SUM(WBP*WV,26))/SUM(WV,26);
for(i=0; i<limit; i++)
      {t1=0;t2=0;t3=0;t4=0;
       for(k=0;k<12;k++)
          {t0=i+k;
          t1=t1+((High[Highest(NULL,0,MODE_HIGH,5,t0)]+Low[Lowest(NULL,0,MODE_LOW,5,t0)]+Close[t0])/3)*(iMA(NULL,0,5,0,MODE_SMA,MODE_VOLUME,t0)*5);
          t2+=(iMA(NULL,0,5,0,MODE_SMA,MODE_VOLUME,t0)*5);}
       t3=t1;t4=t2;
       for(k=12;k<26;k++)
          {t0=i+k;
          t3=t3+((High[Highest(NULL,0,MODE_HIGH,5,t0)]+Low[Lowest(NULL,0,MODE_LOW,5,t0)]+Close[t0])/3)*(iMA(NULL,0,5,0,MODE_SMA,MODE_VOLUME,t0)*5);
          t4=t4+iMA(NULL,0,5,0,MODE_SMA,MODE_VOLUME,t0)*5;}
       L2[i]=t1/t2-t3/t4;}
   
/*NBP:=(HHV(HIGH,20)+LLV(LOW,20)+CLOSE)/3;
MV:=SUM(VOLUME,20);
L3:=(SUM(NBP*MV,12)/SUM(MV,12))-(SUM(NBP*MV,26))/SUM(MV,26);*/

for(i=0; i<limit; i++)
      {t1=0;t2=0;t3=0;t4=0;
       for(k=0;k<12;k++)
          {t0=i+k;
          t1=t1+((High[Highest(NULL,0,MODE_HIGH,20,t0)]+Low[Lowest(NULL,0,MODE_LOW,20,t0)]+Close[t0])/3)*(20*iMA(NULL,0,20,0,MODE_SMA,MODE_VOLUME,t0));
          t2=t2+(20*iMA(NULL,0,20,0,MODE_SMA,MODE_VOLUME,t0));}
       t3=t1;t4=t2;
       for(k=12;k<26;k++)
          {t0=i+k;
          t3=t3+((High[Highest(NULL,0,MODE_HIGH,20,t0)]+Low[Lowest(NULL,0,MODE_LOW,20,t0)]+Close[t0])/3)*(20*iMA(NULL,0,20,0,MODE_SMA,MODE_VOLUME,t0));
          t4=t4+(20*iMA(NULL,0,20,0,MODE_SMA,MODE_VOLUME,t0));}
       L3[i]=t1/t2-t3/t4;}
       
// VM:=(L1+(L2*2)+(L3*3))/6;
for(i=0; i<limit; i++)
   VM[i]=(L1[i]+(L2[i]*2)+(L3[i]*3))/6;
       
/*VMU:=IF(VM>0,VM,null);
{ - this will be the blue histo bars}
VMD:=IF(VM<0,VM,null);
{ - this will be the red histo bars}
CC:=MOV(VM,19,E);
CCS:=REF(CC,-2);
{ -Plots the white moving ave, shifted forward 2 periods as a histogram}
LN:=0;

*/
      
 
   for(i=0; i<limit; i++)
   if (VM[i]>0)
      {VMU[i]=VM[i];VMD[i]=0;}
      
      else if (VM[i]<0)
          {VMU[i]=0;VMD[i]=VM[i];}
          
            else {VMU[i]=0;VMD[i]=0;}
            
   for(i=0; i<limit; i++)
   CC[i]=iMAOnArray(VM,0,19,0,MODE_EMA,i);
            
return(0);
   
}